
Ruby - Bug #20499

Ruby builds on macOS store absolute paths for AR and NM in rbconfig since Ruby 3.2.3/3.3.0

05/20/2024 05:23 PM - Bo98 (Bo Anderson)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: ruby 3.2.4 (2024-04-23 revision

af471c0e01) [arm64-darwin23]

Backport: 3.1: DONTNEED, 3.2: DONE, 3.3:

DONE

Description

This is a regression introduced by https://github.com/ruby/ruby/commit/038f9ade3c4d965415e4956561975454cf9eeb21 and causes

various downstream problems such as https://github.com/ruby/prism/issues/2716. Development tools on macOS are relocatable -

Xcode.app can exist anywhere on the system so it cannot be assumed that the location on the build machine matches the location

on the running machine. If an absolute path must be used, /usr/bin/nm and /usr/bin/ar are acceptable.

Related issues:

Related to Ruby - Bug #20760: Ruby 3.0.6 fails to build on macOS 15.0 24A335 ... Closed

Associated revisions

Revision 8277cf0799145bed0c813bfcc187739f77b3102d - 05/21/2024 08:03 AM - nobu (Nobuyoshi Nakada)

[Bug #20499] Use consistent version tools with CC

As Apple Xcode is relocatable and selectable with xcode-select, use

consistent versions of commands in the same location.

Revision 8277cf0799145bed0c813bfcc187739f77b3102d - 05/21/2024 08:03 AM - nobu (Nobuyoshi Nakada)

[Bug #20499] Use consistent version tools with CC

As Apple Xcode is relocatable and selectable with xcode-select, use

consistent versions of commands in the same location.

Revision 8277cf07 - 05/21/2024 08:03 AM - nobu (Nobuyoshi Nakada)

[Bug #20499] Use consistent version tools with CC

As Apple Xcode is relocatable and selectable with xcode-select, use

consistent versions of commands in the same location.

Revision f8e675221917601e22c4465ec37b7f2352e6dce8 - 05/22/2024 01:45 AM - hsbt (Hiroshi SHIBATA)

Revert "[Bug #20499] Use consistent version tools with CC"

This reverts commit 8277cf0799145bed0c813bfcc187739f77b3102d.

This change break to build with rbenv install ruby-dev with the following error.

touch yjit/target/release/libyjit.a

transdb.h updated

./tool/darwin-ar: line 6: /nm: No such file or directory

./tool/darwin-ar: line 6: exec: /nm: cannot execute: No such file or directory

partial linking yjit/target/release/libyjit.a into yjit/target/release/libyjit.o

Revision f8e675221917601e22c4465ec37b7f2352e6dce8 - 05/22/2024 01:45 AM - hsbt (Hiroshi SHIBATA)

Revert "[Bug #20499] Use consistent version tools with CC"

This reverts commit 8277cf0799145bed0c813bfcc187739f77b3102d.

This change break to build with rbenv install ruby-dev with the following error.

touch yjit/target/release/libyjit.a

transdb.h updated

./tool/darwin-ar: line 6: /nm: No such file or directory

./tool/darwin-ar: line 6: exec: /nm: cannot execute: No such file or directory
partial linking yjit/target/release/libyjit.a into yjit/target/release/libyjit.o

Revision f8e67522 - 05/22/2024 01:45 AM - hsbt (Hiroshi SHIBATA)

Revert "[Bug #20499] Use consistent version tools with CC"

This reverts commit 8277cf0799145bed0c813bfcc187739f77b3102d.

This change break to build with rbenv install ruby-dev with the following error.

touch yjit/target/release/libyjit.a

transdb.h updated

./tool/darwin-ar: line 6: /nm: No such file or directory

./tool/darwin-ar: line 6: exec: /nm: cannot execute: No such file or directory

partial linking yjit/target/release/libyjit.a into yjit/target/release/libyjit.o

Revision 1e08a9f0e9058186db18f29efc6458c00f10a856 - 05/22/2024 04:49 AM - nobu (Nobuyoshi Nakada)

[Bug #20499] Use Xcode owned tools for Xcode clang

Xcode has its own version tools that may be incompatible with genuine

LLVM tools, use the tools in the same directory.

Revision 1e08a9f0e9058186db18f29efc6458c00f10a856 - 05/22/2024 04:49 AM - nobu (Nobuyoshi Nakada)

[Bug #20499] Use Xcode owned tools for Xcode clang

Xcode has its own version tools that may be incompatible with genuine

LLVM tools, use the tools in the same directory.

Revision 1e08a9f0 - 05/22/2024 04:49 AM - nobu (Nobuyoshi Nakada)

[Bug #20499] Use Xcode owned tools for Xcode clang

Xcode has its own version tools that may be incompatible with genuine

LLVM tools, use the tools in the same directory.

Revision d3b139821294f56e6b31e28608c534d9f0920fc2 - 06/11/2024 06:11 PM - k0kubun (Takashi Kokubun)

merge revision(s) 1e08a9f0e9058186db18f29efc6458c00f10a856: [Backport #20499]

    [Bug #20499] Use Xcode owned tools for Xcode clang

    Xcode has its own version tools that may be incompatible with genuine

    LLVM tools, use the tools in the same directory.

Revision d3b139821294f56e6b31e28608c534d9f0920fc2 - 06/11/2024 06:11 PM - k0kubun (Takashi Kokubun)

merge revision(s) 1e08a9f0e9058186db18f29efc6458c00f10a856: [Backport #20499]

    [Bug #20499] Use Xcode owned tools for Xcode clang

    Xcode has its own version tools that may be incompatible with genuine

    LLVM tools, use the tools in the same directory.

Revision d3b13982 - 06/11/2024 06:11 PM - k0kubun (Takashi Kokubun)

merge revision(s) 1e08a9f0e9058186db18f29efc6458c00f10a856: [Backport #20499]

    [Bug #20499] Use Xcode owned tools for Xcode clang

    Xcode has its own version tools that may be incompatible with genuine

    LLVM tools, use the tools in the same directory.

Revision 5141d72fde2528721663ddbc0554ac81ddc0656f - 07/06/2024 02:01 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 1e08a9f0e9058186db18f29efc6458c00f10a856: [Backport #20499]

    [Bug #20499] Use Xcode owned tools for Xcode clang

    Xcode has its own version tools that may be incompatible with genuine

    LLVM tools, use the tools in the same directory.

Revision 5141d72fde2528721663ddbc0554ac81ddc0656f - 07/06/2024 02:01 AM - nagachika (Tomoyuki Chikanaga)
merge revision(s) 1e08a9f0e9058186db18f29efc6458c00f10a856: [Backport #20499]

    [Bug #20499] Use Xcode owned tools for Xcode clang

    Xcode has its own version tools that may be incompatible with genuine

    LLVM tools, use the tools in the same directory.

Revision 5141d72f - 07/06/2024 02:01 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 1e08a9f0e9058186db18f29efc6458c00f10a856: [Backport #20499]

    [Bug #20499] Use Xcode owned tools for Xcode clang

    Xcode has its own version tools that may be incompatible with genuine

    LLVM tools, use the tools in the same directory.

History

#1 - 05/21/2024 09:51 AM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

Applied in changeset git|8277cf0799145bed0c813bfcc187739f77b3102d.

[Bug #20499] Use consistent version tools with CC

As Apple Xcode is relocatable and selectable with xcode-select, use

consistent versions of commands in the same location.

#2 - 06/11/2024 04:15 PM - Eregon (Benoit Daloze)

- Backport changed from 3.1: UNKNOWN, 3.2: UNKNOWN, 3.3: UNKNOWN to 3.1: DONTNEED, 3.2: REQUIRED, 3.3: REQUIRED

#3 - 06/11/2024 06:11 PM - k0kubun (Takashi Kokubun)

- Backport changed from 3.1: DONTNEED, 3.2: REQUIRED, 3.3: REQUIRED to 3.1: DONTNEED, 3.2: REQUIRED, 3.3: DONE

ruby_3_3 d3b139821294f56e6b31e28608c534d9f0920fc2 merged revision(s) 1e08a9f0e9058186db18f29efc6458c00f10a856.

#4 - 07/06/2024 02:01 AM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 3.1: DONTNEED, 3.2: REQUIRED, 3.3: DONE to 3.1: DONTNEED, 3.2: DONE, 3.3: DONE

ruby_3_2 5141d72fde2528721663ddbc0554ac81ddc0656f merged revision(s) 1e08a9f0e9058186db18f29efc6458c00f10a856.

#5 - 09/25/2024 07:43 PM - nobu (Nobuyoshi Nakada)

- Related to Bug #20760: Ruby 3.0.6 fails to build on macOS 15.0 24A335 arm64 added
